#!/usr/bin/env python
# vim: set fileencoding=utf-8 expandtab shiftwidth=4 tabstop=4 softtabstop=4:

import socket
import struct
import uinput

s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
s.bind(('', 20124))

capabilities = {uinput.EV_REL: [uinput.REL_X, uinput.REL_Y],
                uinput.EV_KEY: [uinput.BTN_LEFT, uinput.BTN_RIGHT],
                }

device = uinput.Device(name="python-uinput-mouse", capabilities=capabilities)

data = []
last_counter = { 1: -1, 2: -1 }
x = 0
y = 0
lastx = 0
lasty = 0
while True:
    data = s.recv(1024)
    counter, mesg_type = struct.unpack('!qb', data[0:9])
    if counter > last_counter[mesg_type]:
        last_counter[mesg_type] = counter
    if mesg_type == 1:
        (action,) = struct.unpack('!i', data[9:13])
        if action in [0, 2]:
            x, y = struct.unpack('!2f', data[13:])
            if action == 2:
                device.emit(uinput.EV_REL, uinput.REL_X, int(x-lastx))
                device.emit(uinput.EV_REL, uinput.REL_Y, int(y-lasty))
            lastx = x
            lasty = y
    elif mesg_type == 2:
        action, keycode = struct.unpack('!ii', data[9:])
        if keycode == 23:
            if action == 0:
                device.emit(uinput.EV_KEY, uinput.BTN_LEFT, 1)
            elif action == 1:
                device.emit(uinput.EV_KEY, uinput.BTN_LEFT, 0)
